<template>
  <v-container fill-height fill-width>
    <v-row justify="center" class="align-self-start">
      <SectionTitle
        v-bind:title="'Organisation Management'"
        class="col col-12"
      />
      <NodeInfo />
    </v-row>
    <v-row class="align-self-start" justify="center">
      <v-col cols="10" md="6">
        <div class="overflow-y-auto" style="max-height:40vh">
          <v-list disabled dense v-if="colleagues?.length">
            <p style="height:12px;">Colleagues:</p>
            <v-list-item-title
              class="ml-4"
              v-for="user in colleagues"
              :key="user['id']"
            >
              {{ user["name"] }}
            </v-list-item-title>
          </v-list>
        </div>
        <v-form v-model="valid" class="my-6" ref="form">
          <v-text-field
            v-model="email"
            :rules="emailRules"
            label="Invite a Colleague by email"
            required
            hint="Create account for a new colleague with the same privileges like you"
            persistent-hint
          ></v-text-field>
          <div class="d-flex justify-end mt-6">
            <v-btn
              large
              class="px-9"
              :disabled="!valid"
              @click.prevent="invite"
            >
              Invite
            </v-btn>
          </div>
        </v-form>
        <div class="mt-10">
          <v-text-field
            v-if="loading || isUserLoading"
            loading
            disabled
          ></v-text-field>
          <UIAlert
            v-if="isSuccessed || hasHttpError"
            v-bind:isSuccessful="!hasHttpError"
            v-bind:message="
              isSuccessed
                ? 'User Added successfully'
                : $store.state.application.httpErrorMessage
            "
          />
        </div>
      </v-col>
    </v-row>
  </v-container>
</template>
<script setup lang="ts">
/*
 * This file is Free Software under GNU Affero General Public License v >= 3.0
 * without warranty, see README.md and license for details.
 *
 * SPDX-License-Identifier: AGPL-3.0-or-later
 *
 * SPDX-FileCopyrightText: 2020 nic.at GmbH <https://nic.at>
 * Software-Engineering: 2020 Intevation GmbH <https://intevation.de>
 *
 * Author(s):
 * Fadi Abbud <fadi.abbud@intevation.de>
 */
import {
  computed,
  defineAsyncComponent,
  nextTick,
  onMounted,
  ref,
  watch
} from "vue";
import { HTTP } from "../lib/http";
import { useStore } from "@/store";
import { useForm } from "@/lib/use-form";

const UIAlert = defineAsyncComponent(() =>
  import("@/components/ui/UIAlert.vue")
);
const NodeInfo = defineAsyncComponent(() =>
  import("@/components/ui/NodeInfo.vue")
);
const SectionTitle = defineAsyncComponent(() =>
  import("./ui/SectionTitle.vue")
);
const store = useStore();
const role = computed(() => {
  return store.state.user.selectedNode.level;
});
// Form
const {
  form,
  valid,
  emailRules,
  email,
  loading,
  isSuccessed,
  hasHttpError
} = useForm();
const invite = () => {
  loading.value = true;
  // Reset the the message, hasHttpError values on the seconde try after an Error
  store.commit("application/setHttpErrorMessage", "");
  hasHttpError.value = false;
  isSuccessed.value = false;
  const nodeID =
    ["tenantadmin", "orgaadmin"].indexOf(role.value) !== -1
      ? store.state.user.selectedNode.node_id
      : "";
  HTTP.post(
    "/users",
    role.value === "portaladmin"
      ? {
          email: email.value,
          group: role.value
        }
      : {
          email: email.value,
          group: role.value,
          node_id: nodeID
        }
  )
    .then(() => {
      getColleagues();
      email.value = "";
      nextTick(() => {
        isSuccessed.value = true;
      });
    })
    .catch(() => {
      hasHttpError.value = true;
    })
    .finally(() => {
      loading.value = false;
    });
};
// Colleagues
const colleagues = ref<{ [key: string]: string | number }[]>();
const isUserLoading = ref(false);
const getColleagues = () => {
  isUserLoading.value = true;
  store.commit("application/setHttpErrorMessage", "");
  let route = "/users?row=100&";
  if (store.getters["user/isPortalAdmin"]) {
    route += "type=portaladmin";
  }
  if (store.getters["user/isTenantAdmin"]) {
    route +=
      "type=tenantadmin&node_id=" + store.state.user.selectedNode.node_id;
  }
  if (store.getters["user/isOrgaAdmin"]) {
    route += "type=orgaadmin&node_id=" + store.state.user.selectedNode.node_id;
  }
  HTTP.get(route)
    .then(response => {
      colleagues.value = response.data.data;
    })
    .catch(() => {
      hasHttpError.value = true;
    })
    .finally(() => {
      isUserLoading.value = false;
    });
};
onMounted(() => {
  getColleagues();
});
// Trigger loading colleagues if node changed to list the right users
watch(
  () => store.state.user.selectedNode,
  () => {
    hasHttpError.value = false;
    isSuccessed.value = false;
    getColleagues();
  }
);
</script>
